// lh_w.cpp : Defines the entry point for the application.
//

//#include "stdafx.h"
#include <winsock2.h>
#include <windows.h>
#include "stdlib.h"
#include "stdio.h"
#include "common.h"
#include "lh_w.h"

#define MAX_LOADSTRING 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];					// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];			// the main window class name

// Forward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
INT_PTR CALLBACK	About(HWND, UINT, WPARAM, LPARAM);
HWND g_hWnd = NULL;
HWND g_hLingoesWnd = NULL;
HINSTANCE g_hInstance;
BOOL g_bOnTop = TRUE;

WNDPROC origLingoesWndProc = NULL;
LRESULT CALLBACK myLingoesWndProc(HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	if(message == WM_RBUTTONUP)
		ShowWindow(hwnd, SW_HIDE);

	return 	origLingoesWndProc(hwnd, message, wParam, lParam);
}

BOOL CALLBACK EnumWindowsProc(HWND hwnd, LPARAM lParam)
{
	wchar_t buf[100];
/*	if(GetWindowText(hwnd, buf, 100))
	{
		if(wcsncmp(buf, L"Lingoes", 7) == 0)
		{
			if(GetClassName(hwnd, buf, 100))
			{
				if(wcsncmp(buf, L"Afx:400000", 10) == 0)
				{
					wprintf(L"lingoes window: %08x\n", hwnd);
					//PostMessage(hwnd, WM_MOUSEMOVE, 0, 0);
					//PostMessage(hwnd, WM_MOUSEMOVE, 0, 0x00100010);
					PostMessage(hwnd, WM_USER+1001, 0x80, 0x200);	// mouse move on tray icon
					PostMessage(hwnd, WM_USER+1001, 0x80, 0x200);	// mouse move on tray icon
				}
			}
		}
	}

	if(GetClassName(hwnd, buf, 100))
	{
		if(wcsncmp(buf, L"AfxFrameOrView42u", 17) == 0)
		{
			hwnd = GetParent(hwnd);
			if(GetClassName(hwnd, buf, 100))
			{
				if(wcsncmp(buf, L"Afx:400000", 10) == 0)
				{
					wprintf(L"lingoes window: %08x\n", hwnd);
					PostMessage(hwnd, WM_MOUSEMOVE, 0, 0);
					PostMessage(hwnd, WM_MOUSEMOVE, 0, 0x00100010);
					//PostMessage(hwnd, WM_USER+1001, 0x80, 0x200);	// mouse move on tray icon
					//PostMessage(hwnd, WM_USER+1001, 0x80, 0x200);	// mouse move on tray icon
					return FALSE;
				}
			}
		}
	}
*/
	if(GetClassName(hwnd, buf, 100))
	{
		if(wcsncmp(buf, L"Afx:400000", 10) == 0)
		{
			HWND hwnd1 = GetWindow(hwnd, GW_CHILD);
			while(hwnd1)
			{
				if(GetClassName(hwnd1, buf, 100))
				{
					if(wcsncmp(buf, L"AfxFrameOrView42u", 17) == 0)
					{
						//wprintf(L"lingoes window: %08x\n", hwnd);
						g_hLingoesWnd = hwnd;
						//origLingoesWndProc = (WNDPROC)SetWindowLong(hwnd, GWL_WNDPROC, (LONG)myLingoesWndProc);
						//DWORD dw = GetLastError();
						//ShowWindow(hwnd, SW_HIDE);
						//PostMessage(hwnd, WM_MOUSEMOVE, 0, 0);
						//PostMessage(hwnd, WM_MOUSEMOVE, 0, 0x00100010);
						//PostMessage(hwnd, WM_USER+1001, 0x80, 0x200);	// mouse move on tray icon
						//PostMessage(hwnd, WM_USER+1001, 0x80, 0x200);	// mouse move on tray icon
						return FALSE;
					}
				}
				hwnd1 = GetWindow(hwnd1, GW_HWNDNEXT);
			}
		}
	}

	return TRUE;
}

int hide_lingoes()
{
	//if(origLingoesWndProc == NULL)
	if(g_hLingoesWnd == NULL)
		EnumWindows(EnumWindowsProc, NULL);

	if(g_hLingoesWnd)
		ShowWindow(g_hLingoesWnd, SW_HIDE);

	ShowWindow(g_hWnd, SW_HIDE);

	return 0;
	//HWND hwnd = FindWindow(L"Afx:400000:2400b:10011:0:0", NULL);
	HWND hwnd = FindWindow(NULL, L"Lingoes");
	if(hwnd == NULL)
	{
		wprintf(L"lingoes window not found\n");
		return FALSE;
	}
	wprintf(L"lingoes window: %08x\n", hwnd);
	//ShowWindow(hwnd, SW_HIDE);
	PostMessage(hwnd, WM_MOUSEMOVE, 0, 0);
	PostMessage(hwnd, WM_MOUSEMOVE, 0, 0x00100010);

	return TRUE;
}

int get_clipboard()
{
    HGLOBAL   hglb; 
    LPTSTR    lptstr; 
 
	if (!IsClipboardFormatAvailable(CF_UNICODETEXT)) 
		return FALSE; 
	if (!OpenClipboard(g_hWnd)) 
		return FALSE; 

	hglb = GetClipboardData(CF_UNICODETEXT); 
	if (hglb != NULL) 
	{ 
		lptstr = (LPTSTR)GlobalLock(hglb); 
		if (lptstr != NULL) 
		{ 
			GlobalUnlock(hglb); 
		} 
	} 
	CloseClipboard(); 

	return TRUE;
}

int set_clipboard(wchar_t *str)
{
    wchar_t *  lptstrCopy; 
    HGLOBAL hglbCopy; 
	//MessageBox(g_hWnd, lpCmdLine, L"", MB_OK);

	if(wcslen(str) == 0)
	{
		return TRUE; 
	}

    if (!OpenClipboard(g_hWnd)) 
        return FALSE; 

    EmptyClipboard(); 

	hglbCopy = GlobalAlloc(GMEM_MOVEABLE, (wcslen(str) + 1) * sizeof(TCHAR)); 
	if (hglbCopy == NULL) 
	{ 
		CloseClipboard(); 
		return FALSE; 
	} 

	// Lock the handle and copy the text to the buffer. 

	lptstrCopy = (wchar_t *)GlobalLock(hglbCopy); 
	//WideCharToMultiByte(CP_ACP, 0, str, -1, (LPSTR)lptstrCopy, (wcslen(str) + 1) * sizeof(TCHAR), NULL, NULL);
	wcscpy(lptstrCopy, str);
	GlobalUnlock(hglbCopy); 

	// Place the handle on the clipboard. 
	SetClipboardData(CF_UNICODETEXT, hglbCopy); 

	CloseClipboard(); 

	return TRUE;
}

int main_loop()
{
	RECT lastlingoesrc, lastrc, rc;
	MSG msg;
	int r;
	POINT pt;

	WSADATA wsaData;
	int iResult = WSAStartup(MAKEWORD(2,2), &wsaData);
	if (iResult != NO_ERROR)
		wprintf(L"Error at WSAStartup()\n");

	SOCKET client_sock;
	client_sock = socket(AF_INET, SOCK_STREAM, IPPROTO_TCP);
	if (client_sock == INVALID_SOCKET) {
		wprintf(L"Error at socket(): %ld\n", WSAGetLastError());
		WSACleanup();
		return 1;
	}

	sockaddr_in clientService; 
	clientService.sin_family = AF_INET;
	clientService.sin_addr.s_addr = inet_addr("127.0.0.1");
	clientService.sin_port = htons(SERVER_PORT);
	for(r=0; ; r++)
	{
		if (connect(client_sock, (SOCKADDR*) &clientService, sizeof(clientService) ) != SOCKET_ERROR) 
			break;
		if(r >= 10)
		{
			wprintf( L"Failed to connect.\n" );
			WSACleanup();
			return 2;
		}
		Sleep(200);
	}
	//wprintf(L"Connected to server.\n");

	short buf[1024];
	int shutdown = 0;
	fd_set fds;
	timeval tv;
	tv.tv_sec = 0;
	tv.tv_usec = 50000;
	while(1)
	{
		FD_ZERO(&fds);
		FD_SET(client_sock, &fds);
		r = select(0, &fds, NULL, NULL, &tv);
		if(r == SOCKET_ERROR) 
		{
			wprintf(L"socket error.\n");
			break;
		}
		else if(r == 0) // timeout
		{
			while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

			if(g_hLingoesWnd == NULL)
				EnumWindows(EnumWindowsProc, NULL);

			if(g_hLingoesWnd && IsWindowVisible(g_hLingoesWnd))
			{
				GetWindowRect(g_hLingoesWnd, &rc);
				if(memcmp(&rc, &lastlingoesrc, sizeof(rc)) != 0)
				{
					memcpy(&lastlingoesrc, &rc, sizeof(rc));
					GetCursorPos(&pt);
					if(rc.top > 36 && abs(pt.y-rc.top) <= abs(rc.bottom-pt.y)) // enough room and top is closer to the cursor
					{
						rc.bottom = rc.top;
						rc.top -= 36;
						g_bOnTop = TRUE;
					}
					else
					{
						rc.top = rc.bottom;
						rc.bottom += 36;
						g_bOnTop = FALSE;
					}
					if(memcmp(&rc, &lastrc, sizeof(rc)) != 0)
					{
						//wprintf(L"show main window, %d, %d, %d, %d\n", rc.left,rc.top, rc.right, rc.bottom);
						SetWindowPos(g_hWnd, HWND_TOPMOST, rc.left, rc.top, rc.right-rc.left, rc.bottom-rc.top, SWP_SHOWWINDOW|SWP_NOACTIVATE);
						InvalidateRect(g_hWnd, NULL, TRUE);
						UpdateWindow(g_hWnd);
						memcpy(&lastrc, &rc, sizeof(rc));
					}
				}
			}
			else if(IsWindowVisible(g_hWnd))
			{
				ShowWindow(g_hWnd, SW_HIDE);
			}

			while (PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				TranslateMessage(&msg);
				DispatchMessage(&msg);
			}

			continue;
		}

		r = recv(client_sock, (char*)buf, 2048, 0);
		if(r <= 0)
		{
			wprintf(L"socket error.\n");
			break;
		}
		//hide_lingoes();
		//wprintf(L"received op=%02x, count=%d\n", ntohs(buf[0]), r);
		switch(ntohs(buf[0]))
		{
		case OP_SHUTDOWN:
			shutdown = 1;
			break;
		case OP_TOKEN:
			if(r >= 2048)
				buf[1023] = 0;
			else
				buf[r/2] = 0;
			//wprintf((LPTSTR)&buf[1]);
			//for(int i = 0; i<r/2; i++)
			//	wprintf(L"0x%04x ", (unsigned short)buf[i]);
			//wprintf(L"\n");
			set_clipboard((LPTSTR)&buf[1]);
			break;
		case OP_CLOSEWINDOW:
			hide_lingoes();
			break;
		default:
			break;
		}

		if(shutdown)
			break;
	}


	WSACleanup();

	return 0;
}

/*int WINAPI _WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPTSTR    lpCmdLine,
                     int       nCmdShow)*/
int WINAPI WinMain(
  HINSTANCE hInstance, 
  HINSTANCE hPrevInstance, 
  LPSTR lpCmdLine, 
  int nCmdShow 
) 
{
	UNREFERENCED_PARAMETER(hPrevInstance);
	UNREFERENCED_PARAMETER(lpCmdLine);

 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	g_hInstance = hInstance;
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_LH_W, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow))
	{
		return FALSE;
	}
/*
	wchar_t buf[10];
	buf[0] = 0x662f;
	buf[1] = 0;
	set_clipboard(buf);//lpCmdLine);
	get_clipboard();
	return 0;
*/
	//hide_lingoes();
	main_loop();

	//return TRUE;
	PostMessage(g_hWnd, WM_CLOSE, 0, 0);

	hAccelTable = LoadAccelerators(hInstance, MAKEINTRESOURCE(IDC_LH_W));

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0))
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg))
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}

	return (int) msg.wParam;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage are only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX);

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, MAKEINTRESOURCE(IDI_LH_W));
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= NULL;//MAKEINTRESOURCE(IDC_LH_W);
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, MAKEINTRESOURCE(IDI_SMALL));

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HINSTANCE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindowEx(WS_EX_TOOLWINDOW, szWindowClass, szTitle, WS_CLIPCHILDREN|WS_CLIPSIBLINGS|WS_POPUP,//WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   g_hWnd = hWnd;
   //SetWindowPos(g_hWnd, HWND_TOPMOST, 100, 200, 300, 150, SWP_SHOWWINDOW);
   //ShowWindow(hWnd, nCmdShow);
   //UpdateWindow(hWnd);

   return TRUE;
}

//
//  FUNCTION: WndProc(HWND, UINT, WPARAM, LPARAM)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	RECT rc, rc1;
	HPEN pen, oldpen;

	switch (message)
	{
	case WM_COMMAND:
		wmId    = LOWORD(wParam);
		wmEvent = HIWORD(wParam);
		// Parse the menu selections:
		switch (wmId)
		{
		case IDM_ABOUT:
			DialogBox(hInst, MAKEINTRESOURCE(IDD_ABOUTBOX), hWnd, About);
			break;
		case IDM_EXIT:
			DestroyWindow(hWnd);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
		}
		break;
	case WM_PAINT:
		hdc = BeginPaint(hWnd, &ps);
		// TODO: Add any drawing code here...
		if(g_hLingoesWnd)
		{
			pen = CreatePen(PS_SOLID, 1, RGB(26, 118, 183));
			oldpen = (HPEN)SelectObject(hdc, pen);
			GetWindowRect(hWnd, &rc);
			//GetWindowRect(g_hLingoesWnd, &rc1);
			//wprintf(L"window rect: %d, %d, %d, %d.\n", rc.left, rc.top, rc.right, rc.bottom);
			if(g_bOnTop)//rc.top > rc1.top)
				Rectangle(hdc, 0, 0, rc.right-rc.left, rc.bottom-rc.top+1);
			else
				Rectangle(hdc, 0, -1, rc.right-rc.left, rc.bottom-rc.top);
			SelectObject(hdc, oldpen);
			DeleteObject(pen);
			DrawIcon(hdc, 5, 2, LoadIcon(g_hInstance, MAKEINTRESOURCE(IDI_LH_W)));
			TextOut(hdc, 42, 10, L"Hide capture window", 19);
		}
		EndPaint(hWnd, &ps);
		break;
	case WM_LBUTTONUP:
	//case WM_MOUSEMOVE:
		if(g_hLingoesWnd)
			ShowWindow(g_hLingoesWnd, SW_HIDE);
		ShowWindow(g_hWnd, SW_HIDE);
		//wprintf(L"WM_RBUTTONUP\n");
		break;
	case WM_DESTROY:
		PostQuitMessage(0);
		break;
	default:
		return DefWindowProc(hWnd, message, wParam, lParam);
	}
	return 0;
}

// Message handler for about box.
INT_PTR CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	UNREFERENCED_PARAMETER(lParam);
	switch (message)
	{
	case WM_INITDIALOG:
		return (INT_PTR)TRUE;

	case WM_COMMAND:
		if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL)
		{
			EndDialog(hDlg, LOWORD(wParam));
			return (INT_PTR)TRUE;
		}
		break;
	}
	return (INT_PTR)FALSE;
}
